<?php

/*------------------------------------------------------------------------
# com_spreadsheet
# ------------------------------------------------------------------------
# author DHTMLX
# copyright (c) DHTMLX Ltd, 2011
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.dhtmlx.com
# Technical Support: http://forum.dhtmlx.com/
-------------------------------------------------------------------------*/




// no direct access
defined('_JEXEC') or die('Restricted access');



jimport('joomla.plugin.plugin');
require_once('spreadsheet_common.php');

class plgContentSpreadsheet extends JPlugin {

	protected $sh_cfg;

	public function plgContentSpreadsheet(&$subject, $params) {
		parent::__construct($subject, $params);
		$cfg = new JConfig;
		$this->sh_cfg = new SpreadsheetCfg();
		$this->sh_cfg->set('plugin', $this->get_url());
		$this->sh_cfg->set('connector', $this->get_url().'spreadsheet_data.php');
		$this->sh_cfg->set('sheet', 1);
		$this->check_db();
	}

	public function onBeforeDisplayContent(&$article, &$params, $limitstart = 0) {
		global $mainframe;
		if (isset($article->text))
			$article->text = preg_replace_callback($this->sh_cfg->get('pattern'), Array($this, "replace"), $article->text);
		if (isset($article->introtext))
			$article->introtext = preg_replace_callback($this->sh_cfg->get('pattern'), Array($this, "replace"), $article->introtext);
	}

	public function onContentBeforeDisplay($context, &$article, &$params, $limitstart=0) {
		global $mainframe;
		if (isset($article->text))
			$article->text = preg_replace_callback($this->sh_cfg->get('pattern'), Array($this, "replace"), $article->text);
		if (isset($article->introtext))
			$article->introtext = preg_replace_callback($this->sh_cfg->get('pattern'), Array($this, "replace"), $article->introtext);
	}

	public function replace($matches) {
		$options = Array();
		if (isset($matches[1])) {
			$ms = Array();
			$matches[1] = html_entity_decode($matches[1]);
			preg_match_all($this->sh_cfg->get('pattern_param'), $matches[1], $ms);

			if (isset($ms[1])) {
				for ($i = 0; $i < count($ms[1]); $i++) {
					$options[trim($ms[1][$i])] = trim($ms[2][$i]);
				}
			}
		}

		$matches = explode(":",$matches[1]);
		foreach ($options as $name => $value) {
			$this->sh_cfg->set($name, $value);
		}
		if (!isset($options['height']))
			$this->sh_cfg->set('autoheight', 'true');

		$text = $this->sh_cfg->get_spreadsheet_client();
		return $text;
	}

	protected function get_url() {
		$path = str_replace("\\", "/", pathinfo(__FILE__, PATHINFO_DIRNAME));
		$root = $_SERVER['DOCUMENT_ROOT'];
		$baseurl = $_SERVER['SERVER_NAME'];
		$baseurl .= (strrpos($baseurl, '/') === strlen($baseurl) - 1) ? '' : '/';
		$url = "http://".$baseurl.str_replace($root, "", $path).'/';
		return $url;
	}

	protected function check_db() {
		$cfg = new JConfig;
		$db_prefix = $cfg->dbprefix;
		$query = "SELECT * FROM #__dhx_data";
		$db =& JFactory::getDBO();
		$db->setQuery($query);
		$res = $db->query();
		if ($db->getErrorNum() != 0) {
			$query = "SELECT * FROM #__data";
			$db->setQuery($query);
			$res = $db->query();
			if ($db->getErrorNum() != 0) {
				$queries = $this->sh_cfg->get('queries');
				for ($i = 0; $i < count($queries); $i++) {
					$query = str_replace('#__', $db_prefix, $queries[$i]);
					$db->setQuery($query);
					$res = $db->query();
				}
			} else {
				// rename tables
				$tables_list = array("data", "header", "sheet", "triggers", "user");
				for ($i = 0; $i < count($tables_list); $i++) {
					$db->setQuery("ALTER TABLE {$db_prefix}{$tables_list[$i]} RENAME TO {$db_prefix}dhx_{$tables_list[$i]}");
					$res = $db->query();
				}
			}
			
		}
		$query = "SELECT sheetid FROM {$db_prefix}dhx_triggers LIMIT 1";
		$db->setQuery($query);
		$res = $db->query();
		if ($db->getErrorNum() != 0) {
			// migrate call
			$cwd = getcwd();

			require_once('codebase/php/migrate.php');
			require_once('codebase/php/db_common.php');
			chdir($cwd);

			$j_cfg = new JConfig;
			$res=mysql_connect($j_cfg->host, $j_cfg->user, $j_cfg->password);
			mysql_select_db($j_cfg->db);

			$wrapper = new MySQLDBDataWrapper($res, null);
			$mig = new dhxMigrate($wrapper, $db_prefix.'dhx_');
			$mig->update();
		}
	}

}